<?php
/*
Copyright (C) 2008 NetWebLogic LLC

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class DiggThisButtonAdmin {

	var $topicArray = array('arts_culture', 'autos', 'baseball', 'basketball', 'business_finance', 'celebrity', 'comedy', 'comics_animation', 'design', 'educational', 'environment', 'extreme_sports', 'food_drink', 'football', 'gadgets', 'gaming_news', 'general_sciences', 'golf', 'hardware', 'health', 'hockey', 'linux_unix', 'microsoft', 'mods', 'motorsport', 'movies', 'music', 'nintendo', 'odd_stuff', 'olympics', 'other_sports', 'pc_games', 'people', 'pets_animals', 'playable_web_games', 'playstation', 'political_opinion', 'politics', 'programming', 'security', 'soccer', 'software', 'space', 'tech_news', 'television', 'tennis', 'travel_places', 'world_news', 'xbox');
	var $skinArray = array('medium' => 'medium', 'compact' => 'compact', 'icon'=>'icon', 'large' => 'large');
	var $mediaArray = array('video', 'image', 'news');
	var $posH = array('right', 'left', 'none');
	var $posV = array('top', 'bottom');
	var $shortcode = false;
	var $diggthis_data;
	
	// Class initialization
	function DiggThisButtonAdmin() {
		//Make decision on what to display
		$this->diggthis_data = get_option('diggthis_data');
		add_action('admin_menu', array(&$this, 'menus'));
		add_action('admin_menu', array(&$this, 'metaBox'));
		add_action('wp_insert_post', array(&$this, 'saveSingleOption'));
	}
		
	function menus(){
		$page = add_options_page('Digg This Button', 'Digg This Button', 8, 'diggthisbutton', array(&$this, 'options'));		
	}
	function metaBox(){
		add_meta_box('diggthis','Digg This Button',array(&$this, 'singleOptions'),'post','side');
		add_meta_box('diggthis','Digg This Button',array(&$this, 'singleOptions'),'page','side');
	}
	
	function options() {
		
		if( is_admin() and $_POST['diggthisbutton_submitted']==1 ){
		
			add_option('diggthis_data');
			$diggthis_data = array();
			
			//Build the array of options here
			if(!$errors){
				foreach ($_POST as $postKey => $postValue){
					if( substr($postKey, 0, 8) == 'diggthis' ){
						//For now, no validation, since this is in admin area.
						if($postValue != ''){
							$diggthis_data[substr($postKey, 9)] = $postValue;
						}
					}
				}
				update_option('diggthis_data', $diggthis_data);
				$this->diggthis_data = $diggthis_data;
				?>
				<div class="updated"><p><strong><?php _e('Options saved.','diggthisbutton'); ?></strong></p></div>
				<?php
			}else{
				?>
				<div class="error"><p><strong><?php _e('There were issues when saving your settings. Please try again.', 'diggthisbutton'); ?></strong></p></div>
				<?php				
			}
		}
		?>
		<div class="wrap nwl-plugin">
			<h2>Digg This Settings</h2>			
			<div id="poststuff" class="metabox-holder has-right-sidebar">
				<div id="side-info-column" class="inner-sidebar">
					<div id="categorydiv" class="postbox ">
						<div class="handlediv" title="Click to toggle"></div>
						<h3 class="hndle">Plugin Information</h3>
						<div class="inside">
							<p>This plugin was developed by <a href="http://twitter.com/marcussykes">Marcus Sykes</a> @ <a href="http://netweblogic.com">NetWebLogic</a></p>
							<p>Please visit <a href="http://netweblogic.com/forums/">our forum</a> for plugin support.</p>
						</div>
					</div>
					<div id="categorydiv" class="postbox ">
						<div class="handlediv" title="Click to toggle"></div>
						<h3 class="hndle">Featured NWL Plugins</h3>
						<div class="inside">
                        	<p>Liked this plugin? Here's more we made:</p>
							<p><a href="http://wordpress.org/extend/plugins/login-with-ajax/">Login With Ajax</a></p>
							<p><a href="http://wordpress.org/extend/plugins/twitter-goodies-widgets/">Twitter Goodies Widgets</a></p>
							<p><a href="http://wordpress.org/extend/plugins/meta-tag-manager/">Meta Tag Manager</a></p>
							<p><a href="http://wordpress.org/extend/plugins/events-manager/">Events Manager</a></p>
							<p><a href="http://wordpress.org/extend/plugins/profile/netweblogic">more...</a></p>
						</div>
					</div>
				</div>
				<div id="post-body">
					<div id="post-body-content">
						<p class="updated">Calling all translators! If you'd like to translate this plugin, the language files are in the langs folder. Please email any translations to wp.plugins@netweblogic.com and we'll incorporate it into the plugin.</p>
						<p>If you have any suggestions, come over to our plugin page and leave a comment. It may just happen!</p>
						<form method="post" action="">
							<table class="form-table">
								<tbody id="diggthis-body">
									<tr valign="top" id="diggthis-display-posts">
										<td scope="row">
											<label><?php _e('Display on Posts?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_display_posts" value="1" <?php echo ($this->diggthis_data['display_posts'] == 1) ? 'checked="checked"':'' ?> /> 
										</td>
									</tr>
									<tr valign="top" id="diggthis-display-pages">
										<td scope="row">
											<label><?php _e('Display on Pages?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_display_pages" value="1" <?php echo ($this->diggthis_data['display_pages'] == 1) ? 'checked="checked"':'' ?> /> 
										</td>
									</tr>
									<tr valign="top" id="diggthis-display-lists">
										<td scope="row">
											<label><?php _e('Display on Post Lists?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_display_lists" value="1" <?php echo ($this->diggthis_data['display_lists'] == 1) ? 'checked="checked"':'' ?> /><br/>
											<i><?php _e('e.g. Archives, Front Page, Tag Pages, etc.','diggthisbutton'); ?></i> 
										</td>
									</tr>
									<tr valign="top" id="diggthis-display-lists">
										<td scope="row">
											<label><?php _e('Display on Searches?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_display_searches" value="1" <?php echo ($this->diggthis_data['display_searches'] == 1) ? 'checked="checked"':'' ?> /><br/>
											<i><?php _e('e.g. Results may vary depending on whether your theme calls content or exceprt filters.','diggthisbutton'); ?></i> 
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Digg Skin','diggthisbutton'); ?></label>
										</td>
										<td>
											<select name="diggthis_skin" id="diggthis_skin">
												<?php
												foreach( $this->skinArray as $title => $value ){
													?>
														<option value="<?php echo $value ?>" <?php echo ($this->diggthis_data['skin'] == $value) ? 'selected="selected"':'' ?>><?php echo $title ?></option>
													<?php
												}
												?>
											</select>
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Digg Topic','diggthisbutton'); ?></label>
										</td>
										<td>
											<select name="diggthis_topic" id="diggthis_topic">
												<option value="">Select...','diggthisbutton'); ?></option>
												<?php
												foreach( $this->topicArray as $value ){
													?>
														<option value="<?php echo $value ?>" <?php echo ($this->diggthis_data['topic'] == $value) ? 'selected="selected"':'' ?>><?php echo $value ?></option>
													<?php
												}
												?>
											</select>
											<br/>
											<i><?php _e('This setting applies across all posts and pages. You can set individual post/page settings when editing them.','diggthisbutton'); ?></i> 
										</td>
									</tr>
									<tr valign="top" id="diggthis-related">
										<td scope="row">
											<label><?php _e('Disable Related Posts?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_related" value="1" <?php echo ($this->diggthis_data['related'] == 1) ? 'checked="checked"':'' ?> /><br/>
											<i><?php _e('This option allows you to specify whether links to related stories should be present in the pop up window that may appear when users click the button. Related stories will be present by default.','diggthisbutton'); ?></i>
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Where should the icon go in your post/page?','diggthisbutton'); ?></label>
										</td>
										<td>
											<?php _e('Top/Bottom','diggthisbutton'); ?> : <select name="diggthis_pos_v" id="diggthis_pos_v">
												<?php
												foreach( $this->posV as $value ){
													?>
														<option value="<?php echo $value ?>" <?php echo ($this->diggthis_data['pos_v'] == $value) ? 'selected="selected"':'' ?>><?php echo $value ?></option>
													<?php
												}
												?>
											</select>
											<?php _e('Float','diggthisbutton'); ?> : <select name="diggthis_pos_h" id="diggthis_pos_h">
												<?php
												foreach( $this->posH as $value ){
													?>
														<option value="<?php echo $value ?>" <?php echo ($this->diggthis_data['pos_h'] == $value) ? 'selected="selected"':'' ?>><?php echo $value ?></option>
													<?php
												}
												?>
											</select>
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Inline Style','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="text" name="diggthis_style" value="<?php echo $this->diggthis_data['style'] ?>" style="width:100%;" />
											<br/>
											<i><?php _e('Enter your CSS here, which goes in the containing div. Example :','diggthisbutton'); ?> <code>margin:5px; padding:5px;</code></i> <br />
											<i><?php _e('<strong>Important : </strong>If you place a value here, the display options above this (float and top/bottom) will not apply. Leave blank to reset.','diggthisbutton'); ?></i> 
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Open Digg in New Window?','diggthisbutton'); ?></label>
										</td>
										<td>
											<input type="checkbox" name="diggthis_window" value="1" <?php echo ($this->diggthis_data['window'] == 1) ? 'checked="checked"':'' ?> />
											<br/>
											<i><?php _e('When checked, any clicks open in a new window, as opposed to the default which is to open links in the same browser window.','diggthisbutton'); ?></i> 
										</td>
									</tr>
									<tr valign="top">
										<td scope="row">
											<label><?php _e('Digg Icon Custom CSS','diggthisbutton'); ?></label>
										</td>
										<td>
											<textarea style="width:100%; height:200px;" name="diggthis_css" id="diggthis_css"><?php echo $this->diggthis_data['css'] ?></textarea>
											<br style="clear:both;"/>
											<i><?php _e('If you add CSS here, it will be placed in the head of your document and will disable any styling of the digg buttons.','diggthisbutton'); ?></i>
										</td>
									</tr>
			
								</tbody>
								<tfoot>
									<tr valign="top">
										<td colspan="2">	
											<input type="hidden" name="diggthisbutton_submitted" value="1" />
											<p class="submit">
												<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
											</p>							
										</td>
									</tr>
								</tfoot>
							</table>
						</form>
					</div>
				</div>
			</div>
		</div>
		<?php
	}

		function saveSingleOption($post_id) {
			global $wpdb;
			// verify this came from the our screen and with proper authorization,
			// because save_post can be triggered at other times
	  		if ( !wp_verify_nonce( $_POST['dtb_nonce'], 'dtb_nonce' )) {
	    		return $post_id;
 			}
			foreach ($_POST as $postKey => $postValue){
				if( substr($postKey, 0, 8) == 'diggthis' ){
					//For now, no validation, since this is in admin area.
					if($postValue != '0'){
						$diggthis_data[substr($postKey, 9)] = $postValue;
					}
				}
			}
			if(!update_post_meta($post_id, '_diggthis_data', serialize($diggthis_data))){
				add_post_meta($post_id, '_diggthis_data', serialize($diggthis_data), true);
			}
		}
		function singleOptions() {
			global $post;
			$diggthis_data = unserialize(get_post_meta($post->ID, '_diggthis_data', true));
			// Use nonce for verification
			echo '<input type="hidden" name="dtb_nonce" id="dtb_nonce" value="' .wp_create_nonce( 'dtb_nonce' ) . '" />';
			?>
				<i><?php _e('The options below overwrite global options and only apply to this post/page','diggthisbutton'); ?></i>
				<p><strong><?php _e('Show Digg Button?','diggthisbutton'); ?></strong></p>
				<p>
					<input type="radio" name="diggthis_show" value="0" /> Default<br/>
					<input type="radio" name="diggthis_show" value="yes" <?php echo ($diggthis_data['show'] == 'yes') ? 'checked="checked"':''; ?> /> Yes<br/>
					<input type="radio" name="diggthis_show" value="no" <?php echo ($diggthis_data['show'] == 'no') ? 'checked="checked"':''; ?> /> No
				</p>
				<p><strong><?php _e('Media Type','diggthisbutton'); ?></strong> 
					<select name="diggthis_media" id="diggthis_media">
						<option value="0">default</option>
						<?php
						foreach( $this->mediaArray as $value ){
							?>
								<option value="<?php echo $value ?>" <?php echo ($diggthis_data['media'] == $value) ? 'selected="selected"':'' ?>><?php echo $value ?></option>
							<?php
						}
						?>
					</select>
				</p>
				<p><strong><?php _e('Topic','diggthisbutton'); ?></strong> 
					<select name="diggthis_topic" id="diggthis_topic">
						<option value="0">default</option>
						<?php
						foreach( $this->topicArray as $value ){
							?>
								<option value="<?php echo $value ?>" <?php echo ($diggthis_data['topic'] == $value) ? 'selected="selected"':'' ?>><?php echo $value ?></option>
							<?php
						}
						?>
					</select>
				</p>
				<p><strong><?php _e('Digg Skin','diggthisbutton'); ?></strong> 
                    <select name="diggthis_skin" id="diggthis_skin">
						<option value="0">default</option>
                        <?php
                        foreach( $this->skinArray as $title => $value ){
                            ?>
                                <option value="<?php echo $value ?>" <?php echo ($diggthis_data['skin'] == $value) ? 'selected="selected"':'' ?>><?php echo $title ?></option>
                            <?php
                        }
                        ?>
                    </select>
				</p>
				<p><strong><?php _e('Inline Style','diggthisbutton'); ?></strong></p>
				<p>
                    <input type="text" name="diggthis_style" value="<?php echo $diggthis_data['style'] ?>" style="width:100%;" />
                    <br/>
                    <i><?php _e('Enter your CSS here, which goes in the containing div. Example :','diggthisbutton'); ?> <code>margin:5px; padding:5px;</code></i>
				</p>		
			<?php
		}	
}
// Start this plugin once all other plugins are fully loaded
add_action( 'init', create_function( '', 'global $DiggThisButtonAdmin; $DiggThisButtonAdmin = new DiggThisButtonAdmin();' ), 11 );

?>